import 'dart:async';

import 'package:flutter/material.dart';

mixin SubscriptionState<T extends StatefulWidget> on State<T> {
  final List<StreamSubscription<dynamic>> _streamSubscriptions = <StreamSubscription<dynamic>>[];

  void addSubscription(StreamSubscription<dynamic> streamSubscription) {
    _streamSubscriptions.add(streamSubscription);
  }

  @override
  void dispose() {
    super.dispose();
    cancel();
  }

  void cancel() {
    for (StreamSubscription<dynamic> subscription in _streamSubscriptions.reversed) {
      subscription.cancel();
    }
    _streamSubscriptions.clear();
  }
}
